PShape layer_1, layer_2, layer_3, layer_4;

int ls;
PFont font;

void circuitTree() {

  font = createFont("Arial", 50);
  textFont(font);
  textSize(5);

  float log_n = 3;

  for (int i = 0; i < rows; i++) {
    int year = Year.get(i);
    String genre = Genre.get(i);
    float jp_sale = 0.1;
    if (JP.get(i) != 0) {
      jp_sale = log(JP.get(i)*1000)/log(log_n);
    }
    float log_max_jp = log(11*1000)/log(log_n);
    int jp_rk = JP_rk.get(i);

    float jp_x = map(jp_sale, 0, log_max_jp, 0, ld/2);
    float jp_y = map(year, 1980, 2020, 0, ld);
    float jp_z = map(jp_rk, 1, 16328, 0, ld);
    strokeWeight(3);
    strokeCap(ROUND);
    stroke(color_map.get(genre));
    //println(genre, genre_map.get(genre_move));
    if ( cJP == true) {
      if (genre_move == 0) {
        if (year_move == 0) {
          if (i%2==1) {
            line(-400, jp_z/2, jp_y -ld/2, -400+jp_x, jp_z/2, jp_y -ld/2);
          } else {
            line(-400, -jp_z/2, jp_y -ld/2, -400+jp_x, -jp_z/2, jp_y -ld/2);
          }
        } else {
          if (year == year_map.get(year_move)) {
            if (i%2==1) {
              line(-400, jp_z/2, jp_y -ld/2, -400+jp_x, jp_z/2, jp_y -ld/2);
            } else {
              line(-400, -jp_z/2, jp_y -ld/2, -400+jp_x, -jp_z/2, jp_y -ld/2);
            }
          }
        }
      } else {
        if ( genre.equals(genre_map.get(genre_move))) {
          if (year_move == 0) {
            if (i%2==1) {
              line(-400, jp_z/2, jp_y -ld/2, -400+jp_x, jp_z/2, jp_y -ld/2);
            } else {
              line(-400, -jp_z/2, jp_y -ld/2, -400+jp_x, -jp_z/2, jp_y -ld/2);
            }
          } else {
            if (year == year_map.get(year_move)) {
              if (i%2==1) {
                line(-400, jp_z/2, jp_y -ld/2, -400+jp_x, jp_z/2, jp_y -ld/2);
              } else {
                line(-400, -jp_z/2, jp_y -ld/2, -400+jp_x, -jp_z/2, jp_y -ld/2);
              }
            }
          }
        }
      }
    }


    float eu_sale = 0.1;
    if (EU.get(i) != 0) {
      eu_sale = log(EU.get(i)*1000)/log(log_n);
    }
    float log_max_eu = log(29*1000)/log(log_n);
    int eu_rk = EU_rk.get(i);

    float eu_x = map(eu_sale, 0, log_max_eu, 0, ld/2);
    float eu_y = map(year, 1980, 2020, 0, ld);
    float eu_z = map(eu_rk, 1, 16328, 0, ld);
    strokeWeight(3);
    strokeCap(ROUND);
    stroke(color_map.get(genre));
    if (cEU == true) {
      if (genre_move == 0) {
        if (year_move == 0) {
          if (i%2==1) {
            line(100+ eu_z/2, -ld/2, eu_y -ld/2, 100+ eu_z/2, -ld/2 + eu_x, eu_y - ld/2);
          } else {
            line(100 - eu_z/2, -ld/2, eu_y -ld/2, 100-eu_z/2, -ld/2 + eu_x, eu_y - ld/2);
          }
        } else {
          if (year == year_map.get(year_move)) {
            if (i%2==1) {
              line(100+ eu_z/2, -ld/2, eu_y -ld/2, 100+ eu_z/2, -ld/2 + eu_x, eu_y - ld/2);
            } else {
              line(100 - eu_z/2, -ld/2, eu_y -ld/2, 100-eu_z/2, -ld/2 + eu_x, eu_y - ld/2);
            }
          }
        }
      } else {
        if ( genre.equals(genre_map.get(genre_move))) {
          if (year_move == 0) {
            if (i%2==1) {
              line(100+ eu_z/2, -ld/2, eu_y -ld/2, 100+ eu_z/2, -ld/2 + eu_x, eu_y - ld/2);
            } else {
              line(100 - eu_z/2, -ld/2, eu_y -ld/2, 100-eu_z/2, -ld/2 + eu_x, eu_y - ld/2);
            }
          } else {
            if (year == year_map.get(year_move)) {
              if (i%2==1) {
                line(100+ eu_z/2, -ld/2, eu_y -ld/2, 100+ eu_z/2, -ld/2 + eu_x, eu_y - ld/2);
              } else {
                line(100 - eu_z/2, -ld/2, eu_y -ld/2, 100-eu_z/2, -ld/2 + eu_x, eu_y - ld/2);
              }
            }
          }
        }
      }
    }



    float na_sale = 0.1;
    if (NA.get(i) != 0) {
      na_sale = log(NA.get(i)*1000)/log(log_n);
    }
    float log_max_na = log(41*1000)/log(log_n);
    int na_rk = NA_rk.get(i);

    float na_x = map(na_sale, 0, log_max_na, 0, ld/2);
    float na_y = map(year, 1980, 2020, 0, ld);
    float na_z = map(na_rk, 1, 16328, 0, ld);
    strokeWeight(3);
    strokeCap(ROUND);
    stroke(color_map.get(genre));
    if (cNA == true) {
      if (genre_move == 0) {
        if (year_move == 0) {
          if (i%2 == 1) {
            line(-400+ld, na_z/2, na_y -ld/2, -400+ld-na_x, na_z/2, na_y -ld/2);
          } else {
            line(-400+ld, -na_z/2, na_y -ld/2, -400+ld-na_x, -na_z/2, na_y -ld/2);
          }
        } else {
          if (year == year_map.get(year_move)) {
            if (i%2 == 1) {
              line(-400+ld, na_z/2, na_y -ld/2, -400+ld-na_x, na_z/2, na_y -ld/2);
            } else {
              line(-400+ld, -na_z/2, na_y -ld/2, -400+ld-na_x, -na_z/2, na_y -ld/2);
            }
          }
        }
      } else {
        if ( genre.equals(genre_map.get(genre_move))) {
          if (year_move == 0) {
            if (i%2 == 1) {
              line(-400+ld, na_z/2, na_y -ld/2, -400+ld-na_x, na_z/2, na_y -ld/2);
            } else {
              line(-400+ld, -na_z/2, na_y -ld/2, -400+ld-na_x, -na_z/2, na_y -ld/2);
            }
          } else {
            if (year == year_map.get(year_move)) {
              if (i%2 == 1) {
                line(-400+ld, na_z/2, na_y -ld/2, -400+ld-na_x, na_z/2, na_y -ld/2);
              } else {
                line(-400+ld, -na_z/2, na_y -ld/2, -400+ld-na_x, -na_z/2, na_y -ld/2);
              }
            }
          }
        }
      }
    }


    float glb_sale = 0.1;
    if (GLB.get(i) !=0) {
      glb_sale = log(GLB.get(i)*1000)/log(log_n);
    }
    float log_max_glb = log(83*1000)/log(log_n);
    int glb_rk = GLB_rk.get(i);

    float glb_x = map(glb_sale, 0, log_max_glb, 0, ld/2);
    float glb_y = map(year, 1980, 2020, 0, ld);
    float glb_z = map(glb_rk, 1, 16328, 0, ld);
    strokeWeight(3);
    strokeCap(ROUND);
    stroke(color_map.get(genre));
    if (cGLB == true) {
      if (genre_move == 0) {
        if (year_move == 0) {
          if (i%2 == 1) {
            line(100+ glb_z/2, ld/2, glb_y -ld/2, 100 +glb_z/2, ld/2 -glb_x, glb_y - ld/2);
          } else {
            line(100- glb_z/2, ld/2, glb_y -ld/2, 100 - glb_z/2, ld/2 -glb_x, glb_y - ld/2);
          }
        } else {
          if (year == year_map.get(year_move)) {
            if (i%2 == 1) {
              line(100+ glb_z/2, ld/2, glb_y -ld/2, 100 +glb_z/2, ld/2 -glb_x, glb_y - ld/2);
            } else {
              line(100- glb_z/2, ld/2, glb_y -ld/2, 100 - glb_z/2, ld/2 -glb_x, glb_y - ld/2);
            }
          }
        }
      } else {
        if ( genre.equals(genre_map.get(genre_move))) {
          if (year_move == 0) {
            if (i%2 == 1) {
              line(100+ glb_z/2, ld/2, glb_y -ld/2, 100 +glb_z/2, ld/2 -glb_x, glb_y - ld/2);
            } else {
              line(100- glb_z/2, ld/2, glb_y -ld/2, 100 - glb_z/2, ld/2 -glb_x, glb_y - ld/2);
            }
          } else {
            if (year == year_map.get(year_move)) {
              if (i%2 == 1) {
                line(100+ glb_z/2, ld/2, glb_y -ld/2, 100 +glb_z/2, ld/2 -glb_x, glb_y - ld/2);
              } else {
                line(100- glb_z/2, ld/2, glb_y -ld/2, 100 - glb_z/2, ld/2 -glb_x, glb_y - ld/2);
              }
            }
          }
        }
      }
    }

    //connect line --------------------------
    strokeWeight(3);
    strokeCap(ROUND);
    stroke(color_map.get(genre));
    //line(-1000+jp_x, jp_z -ld/2, jp_y -ld/2, -400+eu_x, eu_z -ld/2, eu_y -ld/2);
  }
}

void setlayer() {

  layer_1 = createShape();
  layer_1.beginShape();
  layer_1.noFill();
  layer_1.stroke(255, 100);
  layer_1.vertex(-400, -ld/2, -ld/2);
  layer_1.vertex(-400, -ld/2, ld/2);

  layer_1.vertex(-400, ld/2, ld/2);
  layer_1.vertex(-400, ld/2, -ld/2);
  layer_1.endShape(CLOSE);

  layer_2 = createShape();
  layer_2.beginShape();
  layer_2.noFill();
  layer_2.stroke(255, 100);
  layer_2.vertex(-400, -ld/2, -ld/2);
  layer_2.vertex(-400, -ld/2, ld/2);

  layer_2.vertex(-400 + ld, -ld/2, ld/2);
  layer_2.vertex(-400 + ld, -ld/2, -ld/2);
  layer_2.endShape(CLOSE);

  layer_3 = createShape();
  layer_3.beginShape();
  layer_3.noFill();
  layer_3.stroke(255, 100);
  layer_3.vertex(-400 + ld, -ld/2, ld/2);
  layer_3.vertex(-400 + ld, -ld/2, -ld/2);
  layer_3.vertex(-400 + ld, ld/2, -ld/2);
  layer_3.vertex(-400 + ld, ld/2, ld/2);
  layer_3.endShape(CLOSE);

  layer_4 = createShape();
  layer_4.beginShape();
  layer_4.noFill();
  layer_4.stroke(255, 100);
  layer_4.vertex(-400 + ld, ld/2, -ld/2);
  layer_4.vertex(-400 + ld, ld/2, ld/2);
  layer_4.vertex(-400, ld/2, ld/2);
  layer_4.vertex(-400, ld/2, -ld/2);
  layer_4.endShape(CLOSE);
}
